/// <reference types="react" />
import { JSONSchema6 } from 'json-schema';
import { DataTypeEditProps, FilterSignature } from '../Filters';
import { SelectProps } from '../Select';
export declare const operators: {
    is: {
        getLabel: (_s: JSONSchema6) => string;
    };
};
declare type OperatorSlug = keyof typeof operators;
interface BooleanFilter extends JSONSchema6 {
    title: OperatorSlug;
    properties?: {
        [k: string]: {
            const: boolean;
        };
    };
}
export declare const decodeFilter: (filter: BooleanFilter) => FilterSignature | null;
export declare const createFilter: (field: string, operator: "is", value: any, schema: JSONSchema6) => BooleanFilter;
export declare const Edit: ({ value, onUpdate, ...props }: DataTypeEditProps & SelectProps<string>) => JSX.Element;
export {};
