import { TextInputProps as GrommetTextInputProps } from 'grommet';
import * as React from 'react';
import { DefaultProps, Omit, RenditionSystemProps } from '../../common-types';
export interface InternalInputProps extends Omit<GrommetTextInputProps, 'placeholder'>, Omit<DefaultProps, 'onSelect'>, React.RefAttributes<HTMLInputElement> {
    onChange?: React.ChangeEventHandler<HTMLInputElement>;
    placeholder?: string;
    type?: string;
    autoFocus?: boolean;
    readOnly?: boolean;
    disabled?: boolean;
    pattern?: string;
    maxLength?: number;
    form?: string;
    invalid?: boolean;
    valid?: boolean;
    emphasized?: boolean;
    monospace?: boolean;
}
export declare type InputProps = InternalInputProps & RenditionSystemProps;
declare const _default: React.FunctionComponent<InputProps>;
export default _default;
