"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var utils_1 = require("../../../../utils");
var STRENGTH_TITLES = ['Very weak', 'Weak', 'Good', 'Strong', 'Very strong'];
var STRENGTH_STYLES = [
    { width: 0 },
    { width: '25%', backgroundColor: 'orange' },
    { width: '50%', backgroundColor: 'yellow' },
    { width: '75%', backgroundColor: 'green' },
    { width: '100%', backgroundColor: 'darkgreen' },
];
var PasswordStrengthContainer = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tpadding-bottom: ", ";\n\tposition: relative;\n\tmargin-top: ", ";\n\tmargin-bottom: ", ";\n\tfont-size: ", ";\n"], ["\n\tpadding-bottom: ", ";\n\tposition: relative;\n\tmargin-top: ", ";\n\tmargin-bottom: ", ";\n\tfont-size: ", ";\n"])), function (props) { return utils_1.px(props.theme.space[1]); }, function (props) { return utils_1.px(props.theme.space[2]); }, function (props) { return utils_1.px(props.theme.space[3]); }, function (props) { return utils_1.px(props.theme.fontSizes[0]); });
var PasswordStrengthMeter = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\ttransition: all ease-out 150ms;\n\tposition: absolute;\n\theight: 4px;\n\tbackground-color: red;\n\tmin-width: 5px;\n\tbottom: 0;\n"], ["\n\ttransition: all ease-out 150ms;\n\tposition: absolute;\n\theight: 4px;\n\tbackground-color: red;\n\tmin-width: 5px;\n\tbottom: 0;\n"])));
var PasswordStrengthText = styled_components_1.default.p(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tmargin: 0;\n\tmargin-bottom: ", ";\n"], ["\n\tmargin: 0;\n\tmargin-bottom: ", ";\n"])), function (props) { return utils_1.px(props.theme.space[2]); });
var PasswordStrength = function (_a) {
    var password = _a.password;
    var _b = React.useState(), strengthScore = _b[0], setStrengthScore = _b[1];
    React.useEffect(function () {
        var zxcvbn = window.zxcvbn;
        if (zxcvbn && password) {
            try {
                var score = zxcvbn(password).score;
                setStrengthScore(score);
            }
            catch (_a) {
            }
        }
    }, [password]);
    if (!password || strengthScore === undefined) {
        return null;
    }
    return (React.createElement(PasswordStrengthContainer, null,
        React.createElement(PasswordStrengthText, null,
            "Password strength: ",
            React.createElement("em", null, STRENGTH_TITLES[strengthScore])),
        React.createElement(PasswordStrengthMeter, { style: STRENGTH_STYLES[strengthScore] })));
};
var PasswordWidget = function (props) {
    var BaseInput = props.registry.widgets.BaseInput;
    return (React.createElement(React.Fragment, null,
        React.createElement(BaseInput, __assign({ type: "password" }, props)),
        props.options.showPasswordStrengthMeter && (React.createElement(PasswordStrength, { password: props.value }))));
};
exports.default = PasswordWidget;
var templateObject_1, templateObject_2, templateObject_3;
